cmake_minimum_required(VERSION 3.5)

project(DAM VERSION 0.1 LANGUAGES CXX)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#定义两个变量，表示头文件路径和库路径
set(OPENSSL_ROOT_DIR "F:/OpenSSL-Win64")
set(OPENSSL_INCLUDE_DIR "${OPENSSL_ROOT_DIR}/include")
set(OPENSSL_LIB_DIR "${OPENSSL_ROOT_DIR}/lib")
find_package(OpenSSL REQUIRED)


add_library(httplib INTERFACE)
target_include_directories(httplib INTERFACE ./HTTPClient/lib)


find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets)


set(PROJECT_SOURCES
        main.cpp
        MainWindow.cpp
        MainWindow.h
        ./MonitorUI/MonitorUI.h
        ./MonitorUI/MonitorTagUI.h
        ./AnalyticUI/FlangeAnalyticUI.h
        ./AnalyticUI/ClearanceAnalyticUI.h
        ./AnalyticUI/GyroscopeAnalyticUI.h
        ./HTTPClient/client.h
        ./HTTPClient/client.cpp
        ./LoginUI/Login.h
        DAM.qrc
)

if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    qt_add_executable(DAM
        MANUAL_FINALIZATION
        ${PROJECT_SOURCES}
    )
# Define target properties for Android with Qt 6 as:
#    set_property(TARGET DAM APPEND PROPERTY QT_ANDROID_PACKAGE_SOURCE_DIR
#                 ${CMAKE_CURRENT_SOURCE_DIR}/android)
# For more information, see https://doc.qt.io/qt-6/qt-add-executable.html#target-creation
else()
    if(ANDROID)
        add_library(DAM SHARED
            ${PROJECT_SOURCES}
        )
# Define properties for Android with Qt 5 after find_package() calls as:
#    set(ANDROID_PACKAGE_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/android")
    else()
        add_executable(DAM
            ${PROJECT_SOURCES}
        )
    endif()
endif()

# 添加include目录
target_include_directories(DAM PRIVATE ${OPENSSL_INCLUDE_DIR})

# 添加链接库
target_link_libraries(DAM PRIVATE OpenSSL::SSL OpenSSL::Crypto)

target_link_libraries(DAM PRIVATE Qt${QT_VERSION_MAJOR}::Widgets httplib)

set_target_properties(DAM PROPERTIES
    MACOSX_BUNDLE_GUI_IDENTIFIER my.example.com
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

install(TARGETS DAM
    BUNDLE DESTINATION .
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

if(QT_VERSION_MAJOR EQUAL 6)
    qt_finalize_executable(DAM)
endif()
